                PROGRAMS SINDBAD, STRUMO, REFORM and STRUAN
                -------------------------------------------
     
                         Updated 90.11.13

                   I.D.Brown and U.D.Altermatt
                      McMaster University
                    Hamilton, Ontario, Canada

                        idbrown@mcmaster.ca
     
   These programs analyse the molecular geometry of (inorganic) crystal
structures.  They are described in a paper in J.Chem.Inf. and Comp.Sci.
Nov. 1989. They use a number of routines in common and share the same
common block definitions (described below). 
The subroutines are all contained in a
series of files in which they are grouped according to function.  Symmetry
operations are handled automaticly using the method described by Altermatt
and Brown (Acta Cryst. A43, (1987) 125-130)
The program is designed to be machine independent but the parameter 'machine'
must be defined once in each program.  At present VAX, NORD and CDC(virtual
memory) can be accomodated.   In a few clearly labelled cases some code 
may need to be activated or deactivated according to the machine.
     
   The files(block size, 2 blocks = 1kB) containing the main 
subroutines are:

   BONDER(145)   Calculates bond distances
   DISLS(144)    Distance Least Squares
   MAPLIB(90)    Calculates a valence sum map
   MODATM        | Routines for generating a
   MODCOM        | structure
   MODOUT        |
   NETLIB(132)   Solves the network equations
   PLOTLB(280)   Graphics terminal plotting routine (Use DPLOTLB on SUN)
   PSYMLB        Finds the symmetry of a complex
   SPANNER(104)  Expands the bond network

   The files containing low level subroutines are:

   CERNLB(50)    matrix inversion routines from CERN     
   MATHLB(121)   low level mathematical and character manipulative routines
   MAINLB(108)   routines performing crystallographic calculations
   CHEMLB(96)    routines performing chemical calculations
   DISTLB(68)    routines required for calculating distances
   BONDER(154)   routines for calculating and checking bonds
   IOLIB(171)    various input and output routines
   SPELIB(171)   routines for calculating special positions
   SYMLIB(55)    routines for manipulating symmetry operators
     
   In addition the programs call routines in the following files for
reading (and writing) crystallographic data
     
   SCFSLB(160)   reads and writes a Standard Crystallographic File (SCFS)
   ICSDLB(115)   reads the archive and output versions of the Inorganic Crystal
             Structure Database (ICSD)
   SHELIB(37)    reads SHELX ouput file
   FREELB(118)   reads an ICSD input file
   CORLIB(39)    reads file from the Cambridge Structure Database (CSD)
   METLIB        reads file in CRYSTMET input format 

The following data files are called by some subroutines:

   SPGR.DAT(55)     A concordance of Hermann-Mauguin (ICSD form) and the
                  Hall space group symbols used in the program
   VALENCE.DAT(87)  Parameters for calculating bond valences
   STRUPLO.HELP(21) Help file for plotting routine (PLOTLB only)

---------------------------------------------------------------------------

REFORM(21) is a program that allows crystallographic data files to be
reformatted.
Specifically a file may be read in SCFS, Cambridge Data File (Ottawa) format,
Inorganic Crystal Structure Database (Ottawa or archive) formats or SHELX
output format.  The symmetry operators and special positions are calculated
and the results written either in SCFS or as a CHEMGRAF free format input.


    REFORM also calls SPGR.DAT, a file containing a concordance of
    Hermann-Mauguin and Hall space group names
----------------------------------------------------------------------------   
SINDBAD(63) (Search the INorganic crystal structure Database for Bonds And
Distances) provides a general molecular geometry calculation including
a provision to calculate only bond distances (inorganic compounds).  
The algorithms used for calculating the bonds are described by Altermatt
and Brown (Acta Cryst.(1985) B41, 240-244).
It can also produce a BONDFILE suitable for use in some of the
analysis programs in STRUMO.  It is particularly designed to work with
the Inorganic Crystal Structure Database but can accept any suitable
input.  Sindbad is designed for batch use but can be run interactively
through the use of commands which are described by the command HELP.

   
-----------------------------------------------------------------------------   
STRUMO is a STRUcture MOdelling and analysis program.  
It is written as an interactive program with prompts and
provides two possiblities.  The expansion and analysis of an known
bonding network. It uses a number of techniques 
(e.g.simplex refinement, distance least squares, valence
maps, Kirchhoff analysis of bonding networks) that can be selected
by the user as the modelling proceeds.

STRUMOR is the development version of STUMO and contains routines for
generating a structure.  These are still under development.

-----------------------------------------------------------------------------
STRUAN is a STRUcture ANalysing program and differs from STRUMO in that
it is command driven and hence suitable for batch jobs.  In particular
it produces tabular results for several structures making comparisons easier.
The command HELP can be used to enquire about legal commands.  (Under 
development)

-----------------------------------------------------------------------------
FILES CALLED BY PARTICULAR PROGRAMS

          strumo  strumor  sindbad  reform  struan

BONDER      *        *        *
CERNLB      *        *        
CHEMLB      *        *        *
CORLIB                        *        *
DISLS       *        *

DISTLB      *        *        *
FREELB                        *
ICSDLB      *        *        *        *
IOLIB       *        *        *        *
MAINLB      *        *        *        *

MAPLIB      *        *
MATHLB      *        *        *        *
METLIB                        *
MODATM               *
MODCOM               *

MODOUT               *
NETLIB      *        *
PLOTLB      *        * 
PSYMLB               *
SCFSLB      *        *        *        *

SHELIB      *        *                 *
SPANNER     *        *                 *
SPELIB      *        *        *        *
SYMLIB      *        *        *

SPGR.DAT    *        *        *        *
VALENCE.DAT *        *        *        *
STRUPLO.HLP *        *
-----------------------------------------------------------------------------
     
The following table shows which routines are called by higher level routines

File #:     1  2  3  4  5  6  7  8  9  10 11 12 13 14 15 16 17 18 19 20 21 22 23
Calls routines
in files below

Programs
  SINDBAD*                                                                      
  STRUMO *+ 
  STRUAN *                                                                   
  REFORM *  

Subroutines
1  CERNLB + -           X                     X  X     X                       
2  CHEMLB      -     X  X           X      X        X     X        X           

3  CORLIB         -                                                            
4  BONDER            -                                                         

5  DISLS  +             -                        X                              
6  DISTLB            X  X  -        X            X  X     X              X   

7  FREELB                     -                                             
8  ICSDLB                        -                                           

9  IOLIB *           X              -      X     X        X        X           
10 MAINLB            X  X     X     X   -  X     X  X  X  X  X  X  X            

11 MAPLIB                                  -     X                            
12 MATHLB*+    X     X  X  X  X     X   X  X  -  X  X  X  X  X  X  X  X  X     

13 MODCOM               X                        -  X
13 MODATM               X                        -  X                           
14 MODOUT                                        X  -                           

15 NETLIB +                                      X     -                      
16 PLOTLB*                                                -                    

17 SCFSLB                                                    -               
18 SHELIB                                              X        -            

19 SPANNER                          X            X                 -           
20 SPELIB            X              X            X  X              X  -        

21 SYMLIB            X  X   X       X            X  X     X           X  -     

Data files
D1 SPGR                                       X                                 
D2 VALENCE                                    X                                 
D3 STRUPLO                                                X                    

    *  This file contains machine dependent code that may need changing when
        compiling on a new machine.  Occurences are flagged "machine dependent"
    +  This file contains double precission arrays and should be compiled using
        the /G_FLOATING qualifier on the VAX

-----------------------------------------------------------------------------  
    NOTES ON THE NAMES OF ARRAYS AND COMMON BLOCKS USED IN MCMASTER
         CRYSTALLOGRAPHIC PROGRAMS
     
NOTE:  Matrices are given as M(row,column)
       default integer names are used exclusively
       all subroutines contain the following two lines:
         implicit character*8 (g)
         implicit character*80 (h)

   ********** FILE MANAGEMENT ARRAYS *******************

/FILES/
-----
nin         input file number
nout        output file number
ndebug      debug output file number(set to 0)
nread       input data file number
nwrite      output data file number
nspgr       inut space group file
machine     computer model 1=vax, 2=nord
nterm       =6 for interactive session, else =0
     
/FILEB/
-----
nval         file for reading special valence
nvalen       file for reading general valence
npage        file for printing header page
nbond        file for reading bonds commands
nindex       file for writing bond file
ntemp        file for writing displacement factors
nmap         file for writing valence map
nstat        file for writing status file
nrang        file for reading distance ranges
nprint       file for writing publishable paper
     
/SWITCH/
------
jfix         0=output rounded to significant figures/1=fixed format
erra         0=do not/1=do calculate errors in angles
nobe         0=do/1=do not calculate errors in bonds
noan         0=do/1=do not calculate angles
ifang        0=do not/1=do remove bonds closer than the given angle
irang        0=do not/1=do read bond ranges for each entry
ibnd         0=do not/1=do calculate bonding distances only
     
/GMENU/
-----
hmenu(20,3)  menus for interactive programs

   ********** MATERIALS CHARACTERISATION ARRAYS ***********

/GTITLE/
------
gent        entry code
hname       name of entry (compound)
hcodn(2)    literature references
htitl(2)    title of paper
hauth(10)   authors of paper
hform(2)    formulae (see also hdata(5,*))
hcomm(7)    comments
grfact      rfactor (A4)
grad        radiation used (A1)
     
/TITLE/
-----
jauth       number of authors names stored
kcomm       number of comments stored

/HREF/
------
HINFO(2,2)   (*,1) CHEMICAL ABSTRACT registry no.
             (*,2) History of data modifications (replaced by 'hist')
GFILEN(5)    (1) Protein Data Bank no.                   
             (2) Cambridge File refcode
             (3) Inorganic Database no. 
             (4) Metal File entry no.
             (5) Powder Diffraction file no.
hist(40)     history of data manipulation

/GFORM/   see SCFS-87 for details
-------
GFORM(24,3)  (*,1) an element name in the chemical formula
             (*,2) an element name in the formula when the formula
                   is derived from crystal structure analysis 
             (*,3) an element name in the formula when it is derived
                   from chemical analysis

/FORM/  see SCFS-87 for details
-----
NFORM(3)    (*) the number of elements in each formula
MFORM       the dimension of the array FORM and GFORM (= 24)
FORM(24,3)  (*,1) the number of atoms of the corresponding element in
                  GFORM in the formula
            (*,2) as above, when the formula is found using crystal
                  structure analysis
            (*,3) as above, when the formula is found with chemical
                  analysis

   ********* UNIT CELL ARRAYS ********************
     
/CELL/
----
a,b,c       unit cell edges (A)
alpha,beta,agamma  unit cell angles (radians)
vol         unit cell volume (A**3)
am(3,3)     metric tensor
icell       0/1 = cell data not stored/stored
     
/ECELL/
-----
da,db,dc    errors in a,b,c
dalpha,dbeta,dgamma  errors in alpha,beta,agamma
dm(9,6)     metric tensors with a+da, b+db etc.
     
/RCELL/
-----
as,bs,ds    reciprocal cell edges (A**-1)
ral,rbe,rga reciprocal cell angles (radians)
rvol        reciprocal cell volume (A**-3)
rm(3,3)     recirocal metric tensor

   *********** SYMMETRY ARRAYS ******************
     
/SYM/
---
nsym        number of symmetry operators stored
msym        dimension of symmetry arrays (=48)
s(3,3,48)   rotation matrix     s(i,j,is)
t(3,48)     translation matrix  t(i,is)
nlt         number of elements stored in array ta
tu(3,4)     lattice translations for current space group in cell fractions
     
/GSYM/
----
glat        lattice type (P,A,B,C,F,I or H)
gcent       A/C acentric/centric
hmsym       Hermann-Mauguin space group symbol
hall        Hall space group symbol
gsysp(2,30) Wyckoff symbol, site symmetry

/SYMA/
----
mult(48,48) symmetry multiplication table
it(3,48)    symmetry translations in integer form (*12)
nsp         number of special positions stored
msp         dimensions of special position arrays (=30)
isptab(48,30) equivalent symmetry operators for a given special
              position
multsp(30)  multiplicity of special postions
sp(3,3,30)  rotation matirix for special position operator  sp(i,j,isp)
tp(3,30)    translation vector for secial position operator tp(i,isp)
     
/ASYMU/
-----
iasym
aslim(3,2)
isyel(3,2)

   ************* ATOM DATA ARRAYS ***********************8
     
/IDENT/
-----
nx          number of independent atoms stored
mx          dimension of independent atom arrays (1000)
oxid(1000)  oxidation number
npos(1000)  number of equivalent positions in unit cell
icn(1000)   cooridnation number
nza(2,1000) period, group in periodic table
nh(1000)    number of attached H atoms
nd(1000)    number of attached D atoms
ialtno(1000)Altermatt special position number
igrp(1000)  group or complex to which atom belongs
     
/GIDENT/
------
gelem(1000) element name (A2)
gdent(1000) atom identifier (A6)
gwyck(1000) Wyckoff letter (A1)
     
/XATOM/
-----
xx(3,1000)  fractional atom coordinates
occu(1000)  site occupation number
valnce(1000) partial valences

     
/EATOM/
----
dxx(3,1000) errors in xx
soccu(1000) erros in occu
     
/TEMP/
----
u(3,3,1000) temperature factors for xatoms
du(3,3,1000)errors in temperature factors
     
/DUMMY/ (redefined 85.12.9: numh=xnumh)
-----
nxh          Number of elements in xnumh
xnumh(10)    Number of dummy atoms of given type (see GDUMMY)
     
/GDUMMY/
------
gdh(10)      Element name of dummy atom of given type
     
/YATOM/
-----
ny          number of atoms stored in yatom arrays
my          dimension of yatom arrays (=1000)
yx(3,1000)  coordinates of stored atoms
iysym(1000) number of the symmetry operator applied to generate
              yatom coordinates
iynum(1000) number of the atom in xatom array used to generate
              the yatom coordinate

/OATOM/
-----
nyo         number of atoms stored in oatom array
myo         dimension of oatom arrays (=1000)
oyx(3,1000) orthogonal coordinates (in A) of atoms in yatom array

   ************* PHYSICAL PROPERTIES *************

/DENS/
----
zform       number of formula units in unit cell
dens        density
ddens       error in density
cdens       calclated density
fwgt        formula weight
waveln      wavelength used for cell (A)
absorb      absorption factor (/mm)
fzero       F(000)
tmprtr      temperature of study

   ************** CHEMICAL PARAMETERS **************     
     
/BOSTT/
----
nbost       number of valence parameter sets stored
mbost       dimensions of bost arrays (=30)
ioxbost(2,30)  oxidation number of defining atoms
ifbost(30)  valence expression type
pbost(5,30) valence parameters
     
/GBOST/
-----
gbost(2,30) names of defining atoms (2A2)
     
     ************* BOND AND CONTACT ARRAYS ************ 
     
/DISTT/ (1985 version)
----
nb            number of distances around current atom stored
mb            dimension of dist array (=30)
idist(5,30)   atom2,symmetry2,translation2(*12)
xdist(6,30)   distance,error,valence,components of distance
minbon        number of distances found below bond minimum
     
/BONDS/ (1984 version)
-----
nbon        number of bonds stored
mbon        dimension of bonds arrays (=300)
ibon(4,300) atom1,atom2, multiplicity, 1/-1 atom1=cation/anion
xbon(6,300) distance, error in distance, valence, dx, dy, dz
isbon(300)  rotation operation applied to atom2
itbon(3,300) translation operation applied to atom2 (integer form)
     
/BONDS/ (1985 version)
-----
nbon        number of bonds stored
mbon        dimension of bond array (=1000)
ibon(5,1000) atom1,symmetry1,translations1(*12)
jbon(5,1000) atom2,symmetry2,translations2(*12)
xbon(6,1000) distance,error,valence,bond components
ifbon(4,1000) bond flags (multiplicity,bond type,disorder flag,local flag)
     
/CONTAC/ (1984 version)
------
ncon         number of contacts stored
mcon         dimension of contact arrays (=300)
icon(10,300) atom1,sym1,itx1,ity1,itz1,atom2,sym2,itx1,ity2,itz2
xcon(3,300)  calculated distance, error, target distance
     
/CONTACC/ (1985 version)
------
ncon         number of contacts stored
mcon         dimension of contac array (=1000)
icon(5,1000) atom1,symmetry1,translation1(*12)
jcon(5,1000) atom2,symmetry2,translation2(*12)
xcon(6,1000) distance,error,target distance,components
ifcon(4,1000) flags(multiplicity,contact type,disorder flag,local flag)
                contact type = 0 (aim), 1 (min), 2 (max)
      
/RANGE/
-----
nj          number of ranges stored
iox(20)     oxidation number of atom types in range
top(20,20)  maximum distance for bonding
bot(20,20)  minimum distance for bonding
ddmax       global maximum distance for bonding
ddmin       golbal minimum distance for bonding
rmax        maximum distance for bonds to current atom
rmin        minimum distance for bonds to current atom
vmax        valence for maximum bond distance
vmin        valence for minimum bond distance
anglx       minimum bond angle
     
/GRANGE/
------
gel(20)     element name for atom type in range

/SPAN/   ((redfinition 85.12.9 value of mya, mbo, dimension of bondlim)
----
nya           number of iyatoms currently used
mya           dimension of iyatom(600)
iyatom(5,600)   listing of atoms in the spanning tree. If iyatom(2,j) is
              zero, iyatom(1,j)=i where the atom stored is
              iyatom(,i)=iyatom(1,i),iyatom(2,i),(iyatom(k,i)+iyatom(k,j),
                                                  k=3,5)
iterm(600)    =1 for an atom terminating the spanning tree, else -1
nbo           number of bonds stored in ibond
mbo           dimension of ibond(600)
ibond(2,600)  two atoms in iyatom forming the bond
xbond(6,600)  vector description of bond (see xbon(6,))
iat           origin atom (in array xatom) of spanning tree
bondlim(2)    minimum and maximum bond valence used in spanning tree\
netind(20)    network index (number of neighbours in each shell around iat)
ifbond(4,600) flags to match those in /bonds/ifbon
     
/INDEP/
-----
ind1         number of bonds stored in inde1
inde1(1000)  symmetry equivalent bonds
ind2         number of contacts stored in inde2
inde2(1000)  symmetry of equivalent contacts

   ********** VALENCE ARRAYS *******************
     
/VAL/
---
xpm(3,3)    min., max. and increment for the three mapping directions
pmap(3)     parameters for mapping functions (ox. state, expon., dummy)
dmax        radius of sphere that contributes to valence calculations
valim(2)    max. and min. value to be plotted (avoids overflows)
jt          function type for mapping
nz1         number of atoms in /ident/ excluded for calculations
igrid(3)    number of grid points for the three plotting directions
     
/GVAL/
----
gor(3)      labels for the three plotting directions
gem(20)     element names of excluded atoms
gdm(20)     identifiers of excluded atoms

    *************** MISCELLANEOUS ARRAYS ***********************8

/VECT/
----
nvect       number of elements in array
mvect       maximum number of elements in array (100)
nvvect(100) number of bonds around each
xvect(3,20,100) vector components (refered to real cell) of up to 20 bonds
            around up to 100 atoms
          
/INDEX/ (1985 version)
-----
jwrite        0=write cations only/1=write all atoms to bond file
jrflag        0=write errors free/1=write all entries to bond file
irflag        non-fatal error counter
ifflag        fatal error counter
iyflag(100)   0=no bonds/1=bonds found to this atom
     
/STATUSS/
------
lent          last entry number read
istat(30)     number of entries found in each status class
     
/MATRIXX/
------
nm            dimension of matrix as written
mm            maximum dimension of matrix(=500)
xm(500,500) DOUBLE PRECISSION matrix
v(500)      DOUBLE PRECISSION vector
im(500,500)   matrix as integer
     
/FRAG/ (under development by IDB)
----
nfrag         number of fragments stored
mfrag         size of fragment arrays (=20)
ianal(20)     number of extended dimensions of array (0-3)
idir(3,20)    Miller indices of chain direction or perpendicular to sheet
nform(20)     number of elements in formula unit of fragment
iform(20,20)  number of atoms of each element in fragment (see GFRAG)
charge(20)    total charge on the fragment
bases(20)     base strength of the fragment
nyat(20)      number of atoms in fragment
nfrat         number of atoms stored in iatfr (includes translationally
               equivalent atoms in adjacent cells)
mfrat         dimensions of iatfr(=600)
iatfr(6,600)  atom number, symmetry number, 3 lattice
               translations (*12), fragment number of atoms in unit cell
ifrcn(600)    internal coordination number of each atom in iatfr
vsum(600)     valence sum of bonds within the fragment for each atom in iatfr

/GFRAG/
 -----
gelm(20,20)   element names of atoms within each fragment

    ******** EXPERIMENTAL DETAILS ************

/GCOND/   see SCFS-87 for details
-------
GCRAD     radiation used to measure the unit cell
GIRAD     radiation used to measure intensities
GDIFF     type of diffractometer
GABS      type of absorption correction made
GREFN     form of structure factor used in refinement
GSTAT     form of structure factors in agreement indices

/COND/   see SCFS-87 for details
------
CONDIT(6,8)  (*,1) Conditions measuring the unit cell;
              wavelength, temperature, minimum 2*theta,
              maximum 2*theta, no. of reflections, undefined
             (*,2) Conditions measuring intensities;
              wavelength, temperature, minimum sin(theta)/lambda,
              max. sin(theta)/lambda, no. of measured reflections,
              undefined
             (*,3) Reflection ranges measuring intensities;
              minimum h, maximum h, min. k, max. k, min. l, max. l
             (*,4) Absorption correction to intensities;
              linear absorption coeffecient (mm-1), minimum absorption
              correction applied, max. absorption correction applied,
              undefined * 3
             (*,5) Merging of equivalent reflections;
              total no. of measured reflections, total no. of symmetry
              independent reflections, agreement index, undefined*3
             (*,6) Details of the final refinement;
              max. shift error, average shift error, max. difference
              density, min. difference density, if reflections with
              I > k*sigma(I(obs)) contribute (set to 999999999. for default),
              if reflections with I > Thresh contribute to refinement
              (set to 999999999. for default)
             (*,7) Statistics of refinement;
              conventional agreement index, weighted agreement index,
              goodness of fit, conventional agreement index for
              I(obs) > IMIN, conventional agreement index for
              IMIN = K*sigma(I(obs)), no. of unobserved reflections
             (*,8) Number of variables used in refinement;
              no. of reflections in refinement, no. of parameters
              refined, no. of global parameters refined, no. of atomic
              parameters refined, no. of isotropic atomic displacement
              parameters refined, no. of anisotropic atomic displacement
              parameters refined

NSTD         Number of elements stored in CSTD (.LE. MSTD)
MSTD         Dimension of the array CSTD (= 4)
CSTD(6,4)    Details of standard reflection used for monitoring intensity
             measurements.
             (1,*) h   \
             (2,*) k    Miller index of a standard reflection
             (3,*) l   /
             (4,*) average intensity measured
             (5,*) standard deviation
             (6,*) undefined

/HTEXT/   see SCFS-87 for details
-------
GCRYST(2)   (1) extinction theory flag (see CRYSTAL in SCFS-87)
            (2) extinction parameter specifier
GTWIN(5)    (*) twin identifier
HTEXT(10,5) (*,1) ABST abstract of the paper
            (*,2) INTR introduction to the paper
            (*,3) EXPT description of experimental method
            (*,4) DESC description of structure or crystal properties
            (*,5) DISC discussion of the results of the experiment
HDATA(4,19) (*,1) IUPAC name
            (*,2) other chemical name
            (*,3) description of the source of material
            (*,4) description of the preparation of the material
            (*,5) chemical formula (replaces hform in /gtitle/)
            (*,6) information about the solid state phase
            (*,7) definition of angles use in the diffractometer
            (*,8) absorption correction
            (*,9) definition of the orientation matrix
            (*,10) extinction correction
            (*,11) method used for structure solution
            (*,12) source of atomic scattering functions (form factors)
            (*,13) weighting scheme used in refinement 
            (*,14) treatment of hydrogen atoms in refinement
            (*,15) list of programs used
            (*,16) choice of origin of the unit cell
            (*,17) algorithm used for generating symmetry operators
            (*,18) algorithm used for generating special positions
            (*,19) description of disorder

/CRYST/  see SCFS-87 for details
------
SCALE      scale factor
ESCALE     standard error in SCALE
EXTE(6,2)  (*,1) extinction parameters (see /HTEXT/ GCRYST)
           (*,2) errors in the extinction parameters
ABST       absolute structure parameter
ABSTE      error in ABST
TVOL(5)    (*) volume fraction of the twin
ETVOL(5)   (*) error in TVOL 
