C
C                   FILE DISTLB                Last update: 9 June 1992
C                   -----------                             C.Brodie
c
c    This file contains standard FORTRAN-77 code
C    This file contains only single precision arrays
C
C  S CALBO(I,J,IFL)            STORES A BOND FROM =I= TO =J= IN COMMON /BONDS/
C  S CALCON                    CALCULATES THE CONTACTS BETWEEN ALL ANIONS
C  F XLENG(X,Y,Z,I)            RETURNS LENGTH OF VECTOR (X,Y,Z) WITH RESPECT
C                              TO AM(9) (I=0) OR DM(9) (I=1)
C  S ERRLN(ER,ALE,X,Y,Z,I,J)   CALCULATES A BOND ERROR (SEE EXPLANATION)
C  S RANGES(I,J,DMAX,DMIN)     FINDS THE RANGE FOR THE BOND LENGTH =I= TO =J=
C  S WKBOND(II,I)              STORES A DUMMY BOND IN COMMON /BONDS/
C  S DUMMYH                    STORES DUMMY BONDS TO DUMMY H ATOMS IN /BONDS/
C  S INDEPB(N,L1,L2)           SETS DEPENDENCE FLAGS FOR BONDS/CONTACS (N=1/2)
C  S CBREDU(N,L1,L2)           REMOVES DEPENDENT BONDS/CONTACTS (N=1/2)
C  S BONFIT(I,J,JS,JL,K,KS,KL) IF BOND(I) USES ATOM J, K IS THE OTHER ATOM
C                               JS-KL RETURNED, ELSE K=0
C  F IBONDY(I,J,IF)            RETURNS THE ADDRESS IN /BONDS/ OF THE BOND
C                              BETWEEN ATOMS I AND J IN /YATOM/ COMPARING IF
C                              FIELDS OF IBON,JBON
C  S CHEBON(I,N,NBON,IBON)     FINDS ATOM =I= IN IBON, SEARCHING FROM N TO NBON
C  S CHECON(I,N,NCON,ICON,JCON,IP1,IP2)          AS ABOVE, BUT FOR ICON/JCON
C  S COBOTR(N,I,IS,LI,J,JS,LJ) TRANSFORMS A BOND/CONTACT SO THAT IS BECOMES 1
C                              AND LI(3) 0. FOR N.GT.0 I WILL BE .LT. J
C  S BOCOLE(N,K1,K2)           UPDATES (CALCULATES) THE BOND(N=1) OR CONTACT
C                              (N=2) LENGTHS BETWEEN K1 AND K2
C  S corget                    explores the environment of an atomic position
c  F ibondx(i,j)               returns first address in /bonds/ of bond between
c                              atoms i and j in /xatom/
C
C     THE FOLLOWING EXTERNALS ARE CALLED:
C
C  CHEMLB: cost,abost,acid,bost,contac,dbost,ldval
C  MAINLB: calcy, inerr
C  MATHLB: DIST, INTEGER, IVPLUV, MXV, SQART, VMINV, jcomve, angle, maxdim,
C          readyn, sorty, 
C  SPANNER: expand, jyat
C  SPELIB: naltno
C  SYMLIB: GETSTL, INVSOP, MLTSTL, SYMTRN, SYMOPL,mulstl
C
C******  STANDARD FORTRAN 77 CODE ONLY USED IN THIS FILE
C******  SINGLE PRECISSION ONLY USED IN THIS FILE
C
C
C
      SUBROUTINE CALBO(I,J,IFL)
C
C  *****SUBROUTINE*****          CALBO
C                                -----
C
C  WRITTEN 80.6.1 BY DOUG THIERS
C   REWRITTEN 83.9.20 BY I D BROWN / 84.6.12  D. ALTERMATT
C
C  CALLS ERRLN, GETSTL, INTEGER, IVPLUV, RANGES, VMINV, XLENG
C
C  THIS ROUTINE STORES A BOND IN /BONDS/ IF THE LENGTH
C  IS IN (RMIN,RMAX)
C
C  FLAG EXPLANATION:
C     IFL = -1         DISTANCE TOO LONG FOR BOND OR OVERFLOW
C            0         OK, BOND STORED
C            1         DISTANCE TOO SHORT FOR BOND
C            2         DISTANCE TO ITSELF
C
      IMPLICIT CHARACTER*8 (G)
C
      COMMON /FILES/  NIN,NOUT,NDEBUG,nread,nwrite,nspgr,machine,nterm
      include 'comatom.for'
      include 'combond.for'
      COMMON /SYM/    NSYM,MSYM,S(3,3,48),T(3,48)
C
      DIMENSION DY(3),L0(3)
      DATA L0/0,0,0/
C
      IFL=-1
      CALL VMINV(DY,YX(1,J),XX(1,I))
      DIST=XLENG(DY(1),DY(2),DY(3),0)
      CALL RANGES(I,IYNUM(J),DMAX,DMIN)
      IF(DIST.GT.DMAX) RETURN
      CALL ERRLN(ERRR,DIST,DY(1),DY(2),DY(3),I,J)
      IF(DIST.LT.DMIN) THEN
C       DISTANCE IS TOO SHORT
C       ---------------------
          JJ=IYNUM(J)
          IF(OCCU(I)+OCCU(JJ).LE.1.0) THEN
C         DISORDER: IGNORE SHORT DISTANCE
C         -------------------------------
            IFL=1
            RETURN
            ELSE
            IF(DIST.LT.0.01.OR.DIST+3.*ERRR.LT.DMIN) THEN
C           DISTANCE+ERROR IS STILL TOO SMALL (OR ATOM IS ITSELF)
C           ---------------------------------
              IFL=1
              IF(GELEM(I).NE.GELEM(JJ).OR.GDENT(I).NE.GDENT(JJ)
     1          .OR.DIST.GT.0.01) IFL=2
              RETURN
              ENDIF
            ENDIF
        ENDIF
      IFL=0
C
C   ------DETERMINE TRANSLATIONS -----------
C
      N=IYNUM(J)
      IS=IYSYM(J)
      NBON=NBON+1
      IF(NBON.GT.MBON) GOTO 90
         IBON(1,NBON)=I
         IBON(2,NBON)=1
         CALL IVPLUV(IBON(3,NBON),L0,L0)
         JBON(1,NBON)=N
         JBON(2,NBON)=IS
         CALL GETSTL(JBON(3,NBON),N,YX(1,J),IS)
         XBON(1,NBON)=DIST
         XBON(2,NBON)=ERRR
         XBON(3,NBON)=0.0
         do 80 k=1,3
   80      xbon(k+3,nbon)=dy(k)
         IFBON(1,NBON)=1
      RETURN
C
C  ERROR
C
   90 WRITE(NOUT,2000)
 2000 FORMAT(1X,'++ERROR++CALBO: OVERFLOW IN COMMON /BONDS/,',
     1      ' BOND NOT STORED',/)
      NBON=NBON-1
      IFL=-1
      RETURN
C**  THIS PROGRAM VALID ON FTN4 AND FTN5 **
      END
C
C
***********************************************************************
C
C
      subroutine calcon(xlim)
c     -----------------
c
c   written 86.9.10 by I.D.Brown
c
c   This routine calculates the contacts in the coordination spheres 
c   around all cations and stores them in /contac/.  An estimate of the 
c   target distance is made based on the valences of the bond that 
c   define the contacts; the stronger the bond to a common cation the
c   shorter the target contact distance.
c
c   rotuines called
c
c   CHEMLB: cost
c   MATHLB: sqart, vminv, jcomve, dist, angle, maxdim
c   SPANNER: expand, jyat
C
      implicit character*8 (g)
      implicit character*80 (h)
c
      common /files/ nin,nout,ndebug,nread,nwrite,nspgr,machine,nterm
      common /cell/ a,b,c,alpha,beta,agamma,vol,am(3,3),icell
      common /sym/ nsym,msym,s(3,3,48),t(3,48),nlt,tu(3,4)
      common /syma/ mult(48,48),it(3,48),nsp,msp,isptab(48,30),
     +              multsp(30),sp(3,3,30)
      include 'comatom.for'
      include 'combond.for'
      common /span/ nya,mya,iyatom(5,600),iterm(600),
     +              nbo,mbo,ibond(2,600),xbond(6,600),iat,bondlim(2)
      dimension contact(3),jyatom(5),kyatom(5)
c
      bondlim(1)=0.
      bondlim(2)=5.
      cerr=50.
      pi=3.14159
      nco=0
      ncon=0
      if(xlim.lt.0.00001) xlim=14.
c
c   loop through all the anions and calculate bonds to second neighbours
c   --------------------------------------------------------------------
      do 490 i=1,nx
        if(oxid(i).lt.0) then
          iat=i
          itype=-2
          call expand(itype)
          nc1=ncon+1
c
c   store potential connections
c   ---------------------------
          if(ndebug.ne.0) write(ndebug,1410) i,nya,nbo
 1410       format(' *debug*calcon*1410* Environment of atom ',I3,
     +      ' has ',I3,' atoms and ',I3,' bonds')
          do 420 j=1,nya
            call jyat(j,kyatom)
            if(oxid(kyatom(1)).lt.0.and.kyatom(1).ge.i) then
              ncon=ncon+1
              if(maxdim(ncon,mcon,'*CALCON*410* contact').ne.0)
     1              go to 421
              do 410 ll=1,5
                icon(ll,ncon)=iyatom(ll,1)
                jcon(ll,ncon)=kyatom(ll)
  410           continue
              xcon(3,ncon)=0.
              endif
  420       continue
c
c   loop through the bonds to the second neighbours
c   -----------------------------------------------
  421     do 450 j=1,nbo
            if(ibond(1,j).eq.1) then
              call jyat(ibond(2,j),jyatom)
              jcn=icn(jyatom(1))
              if(jcn.eq.0) then
                write(nout,1420) jyatom(1)
 1420           format(' **WARNING**CALCON**1420** Coordination ',
     +           'number of atom ',I3,'not given; assumed to be six')
                jcn=6
                endif
              anlim=xlim*sqart(float(jcn))
              if(jcn.le.2) anlim=-1.
              do 440 k=1,nbo
                if(ibond(1,k).eq.ibond(2,j)) then
                  call jyat(ibond(2,k),kyatom)
                  call vplusv(contact,xbond(4,j),xbond(4,k))
c             eliminate contacts that are too close to the bonds
c             --------------------------------------------------
                  angj=angle(contact,xbond(4,j),am)
                  if(angj.gt.anlim.and.angj.lt.(180.-anlim)) then
                    angk=angle(contact,xbond(4,k),am)
                    if(angk.gt.anlim.and.angk.lt.(180.-anlim)) then
                      do 430 l=nc1,ncon
                        if(jcomve(jcon(1,l),kyatom,5).eq.0) then
                          xcon(1,l)=dist(contact,am)
                          xcon(2,l)=xcon(1,l)/cerr
                          xcon(3,l)=xcon(3,l)+
     1                       2/(1/(xbon(3,j)*abs(cos(pi*angj/180.)))
     1                        +1/(xbon(3,j)*abs(cos(pi*angk/180.))))
                          do 425 ll=1,3
  425                       xcon(ll+3,l)=contact(ll)
                          endif
  430                   continue
                      endif
                    endif
                  endif
                  if(ndebug.ne.0) write(ndebug,1440) j,k,angj,angk,
     +                                       dist(contact,am)
 1440               format(' *debug*calcon*1440* ',2I3,3F10.3)
  440           continue
              endif
  450       continue
          if(ndebug.ne.0) then
            do 455 j=nc1,ncon
  455         write(ndebug,1455)(icon(jj,j),jj=1,5),(jcon(jj,j),jj=1,5)
     +         ,(xcon(jj,j),jj=1,6)
 1455         format(' *debug*calcon*1455* ',10I4,6F6.3)
            endif
c
c    remove distances that are not true contacts (i.e. contact valence = 0)
c    ----------------------------------------------------------------------
          j=nc1
c         begin loop of j=nc1,ncon
  458       continue
            if(abs(xcon(3,j)).lt.0.001) then
              do 470 k=j,ncon-1
                do 460 ll=1,6
                  xcon(ll,k)=xcon(ll,k+1)
                  if(ll.gt.5) go to 460
                  icon(ll,k)=icon(ll,k+1)
                  jcon(ll,k)=jcon(ll,k+1)
                  if(ll.gt.4) go to 460
                  ifcon(ll,k)=ifcon(ll,k+1)
  460             continue
  470           continue
              ncon=ncon-1
            else
              j=j+1
              endif
            if(j.le.ncon) go to 458
c           end of j loop
          endif
  490   continue
c
c   convert contact valences to distances and print
c   -----------------------------------------------
      write(nout,1510) ncon
 1510 format(1X,I5,' contacts generated')
      ntemp=nout
      if(nterm.ne.0) then
  520   write(nout,1520)
 1520   format(' Do you want a list of the contacts on the screen',
     +     ' (Y/N/E) ')
        call readyn(*535,*530,*900,*520)
  530   write(nout,1530) hfilen(nwrite)
 1530   format(' Contacts written to file ',A30)
        ntemp=nwrite
        endif        
  535 write(ntemp,1540)
 1540 format(/,' Listing of the contacts generated',/)
      linc=0
      do 550 i=1,ncon
        linc=linc+1
        if(xcon(3,i).gt.0.001) then
          xcon(3,i)=cost(gelem(icon(1,i)),gelem(jcon(1,i)),xcon(3,i))
        else
          write(ntemp,1541) i
 1541     format(' *WARNING*CALCON*1541* Valence of contact ',I3,
     +               ' less than 0.001. Distance not calculated')
          endif
        ii=icon(1,i)
        jj=jcon(1,i)
        write(ntemp,1550) gelem(ii),gdent(ii),(icon(j,i),j=2,5),
     +   gelem(jj),gdent(jj),(jcon(j,i),j=2,5),(xcon(j,i),j=1,6)
 1550   format(1X,2(A2,A6,4I3,1X),F6.3,'(',F5.3,')',4F6.3)
        if(nterm.ne.0.and.ntemp.eq.nout.and.linc.eq.20) then
          call wait
          linc=0
          endif
  550   continue
      return
c
c   error exit
c   ----------
  900 return
      end
C
***********************************************************************
C
      FUNCTION XLENG(X,Y,Z,I)
C
C  *****FUNCTION*****          XLENG
C                              -----
C
C  WRITTEN 80.6.1 BY DOUG THIERS
C
C  CALLS SQART
C
      COMMON/CELL/ A,B,C,AL,BE,AGA,VOL,AM(9)
      COMMON/ECELL/ DA,DB,DC,DAL,DBE,DGA,DM(9,6)
C
C SUBROUTINE TO CALCULATE THE BONDLENGTH OR ERROR IN THE BONDLENGTH
C DUE TO ERROR IN (A,B,C,ALPHA,BETA,GAMMA).IF(I=0),THE BONDLENGTH IS
C CALCULATED,ELSE I=1,6, THE LENGTH WITH ITH PARAMETER P(I)+DP(I) IS
C CALCULATED.
C
      IF(I.NE.0) GOTO 10
         TEMP1=AM(1)*X+AM(2)*Y+AM(3)*Z
         TEMP2=AM(4)*X+AM(5)*Y+AM(6)*Z
         TEMP3=AM(7)*X+AM(8)*Y+AM(9)*Z
         XLENG=SQART(X*TEMP1+Y*TEMP2+Z*TEMP3)
         RETURN
   10 CONTINUE
         TEMP1=DM(1,I)*X+DM(2,I)*Y+DM(3,I)*Z
         TEMP2=DM(4,I)*X+DM(5,I)*Y+DM(6,I)*Z
         TEMP3=DM(7,I)*X+DM(8,I)*Y+DM(9,I)*Z
         XLENG=SQART(TEMP1*X+TEMP2*Y+TEMP3*Z)
         RETURN
C**  THIS PROGRAM VALID ON FTN4 AND FTN5 **
      END
C
C
***********************************************************************
C
C
      SUBROUTINE ERRLN(ERRL,ALENG,X,Y,Z,I,J)
C
C  *****SUBROUTINE*****          ERRLN
C                                -----
C
C  WRITTEN 80.6.1 BY DOUG THIERS
C
C  CALLS XLENG, MXV, SQART
C
C
C  THIS SUBROUTINE CALCULATES THE ERROR IN THE BOND (X,Y,Z) BETWEEN
C  THE ITH PRIMITIVE ATOM AND THE JTH UNIT CELL ATOM.IT ACCUMULATES
C  THE ERROR (XLENG(...P(I)+DP(I)...) - XLENG(...P(I)...)**2 DUE TO
C  EACH DP(I)=(DA,DB,DC,DALPHA,DBETA,DGAMMA,DX(I),DY(I),DZ(I),DX(J),
C  DY(J),DZ(J))
C
      include 'comatom.for'
      COMMON/SYM/NSYM,MSYM,S(3,3,48),T(3,48)
      DIMENSION DA(3)
      ERRL=0.0
C
C  ACCUMULATE ERRORS DUE TO LATTICE PARAMETERS.
C
      DO 15 K=1,6
         ERRL=ERRL + (XLENG(X,Y,Z,K)-ALENG)**2
   15 CONTINUE
C
C  ACCUMULATE ERRORS DUE TO ATOM POSITION READINGS.
C
      IA = IYNUM(J)
      IS = IYSYM(J)
      CALL MXV(DA,S(1,1,IS),DXX(1,IA))
      ERRL=ERRL+ (XLENG(X+DXX(1,I),Y,Z,0)-ALENG)**2
      ERRL=ERRL+ (XLENG(X+DA(1),Y,Z,0)-ALENG)**2
      ERRL=ERRL+ (XLENG(X,Y+DXX(2,I),Z,0)-ALENG)**2
      ERRL=ERRL+ (XLENG(X,Y+DA(2),Z,0)-ALENG)**2
      ERRL=ERRL+ (XLENG(X,Y,Z+DXX(3,I),0)-ALENG)**2
      ERRL=ERRL+ (XLENG(X,Y,Z+DA(3),0)-ALENG)**2
      ERRL=SQART(ERRL)
      RETURN
C**  THIS PROGRAM VALID ON FTN4 AND FTN5 **
      END
C
C
***********************************************************************
C
C
      SUBROUTINE RANGES(II,JJ,DMAX,DMIN)
C
C   *****SUBROUTINE*****        RANGES
C                               ------
C
C   WRITTEN 81.7.22 BY I D BROWN
C
C   CALLS INTEGER
C
C   FIND THE RANGE FOR THE BOND BETWEEN ATOM II AND ATOM JJ
C
      IMPLICIT CHARACTER*8 (G)
C
      include 'comatom.for'
      COMMON/RANGE/NJ,IOX(20),TOP(20,20),BOT(20,20),DDMAX,DDMIN,
     1             RMAX,RMIN,VMAX,VMIN,ANGLX
      COMMON/GRANGE/GEL(20)
      DO 50 I=1,NJ
      IF(GELEM(II).NE.GEL(I)) GO TO 50
      INTOX=INTEGER(OXID(II),0)
      IF(IOX(I).EQ.0 .OR. INTOX.EQ.0) GOTO 30
      IF(INTOX.NE.IOX(I))GOTO 50
         DMAX = TOP(I,1)
         DMIN = BOT(I,1)
   30 DO 40 J=1,NJ
      IF(GELEM(JJ).NE.GEL(J)) GO TO 40
      INTOX=INTEGER(OXID(JJ),0)
      IF(IOX(J).EQ.0 .OR. INTOX.EQ.0) GOTO 35
      IF(INTOX.NE.IOX(J)) GOTO 40
   35       DMAX = TOP(I,J)
            DMIN = BOT(I,J)
            GO TO 100
   40       CONTINUE
         GO TO 100
   50    CONTINUE
      DMAX = DDMAX
      DMIN = DDMIN
  100 RETURN
C**  THIS PROGRAM VALID ON FTN4 AND FTN5 **
      END
C
C
***********************************************************************
C
C
      SUBROUTINE WKBOND(II,I)
C                ======
C
C   WRITTEN 83.1.30 BY I D BROWN
C   MODIFIED 85.5.14 BY DAVID KNIGHT
C
C   WRITES DUMMY BONDS TO BOND FILE STORE
C
      include 'combond.for'
C
      IBON(1,NBON) = II
      JBON(1,NBON) = I
      DO 10 J=2,5
        IBON(J,NBON)=0
        JBON(J,NBON)=0
   10   CONTINUE
      RETURN
      END
     
C
C
***********************************************************************
C
C
      SUBROUTINE DUMMYH
C                ======
C
C   WRITTEN 83.3.9 BY I D BROWN
C   COMMON BLOCKS CHANGED 85.5.14 BY DAVID KNIGHT
C
C   STORES DUMMY BONDS TO DUMMY H ATOMS IN COMMON /BONDS/
C
C   CALLS  WKBOND
C
C   USES   INTEGER
C
      IMPLICIT CHARACTER*8 (G)
      IMPLICIT CHARACTER*80 (H)
      COMMON/FILES/ NIN,NOUT,ndebug,nread,nwrite,nspgr,machine,nterm
      include 'comatom.for'
      include 'combond.for'
      COMMON/INDEX/JWRITE,JRFLAG,IRFLAG,IFFLAG,IYFLAG(100)
      COMMON/DUMMY/NXH,XNUMH(10)
      COMMON/GDUMMY/GDH(10)
      XH1=0.0
      XH2=0.0
      DO 10 I=1,NX
        IF(NH(I).GT.0) XH1=XH1+NH(I)*NPOS(I)*OCCU(I)
        IF(ND(I).GT.0) XH1=XH1+ND(I)*NPOS(I)*OCCU(I)
  10    CONTINUE
C
C   WRITE BONDS FOR H ATOMS WITHOUT COORDINATES
C
      IF(NXH.EQ.0) THEN
      DO 100 I=1,NX
        IF(OCCU(I).LT.1.1.AND.XX(1,I).LT.5.) GO TO 100
        IF(GELEM(I).EQ.'H ') GO TO 40
        IF(GELEM(I).EQ.'D ') GO TO 70
        GO TO 100
   40   XH2=XH2+OCCU(I)*NPOS(I)
        DO 60 J=1,NX
          IF(NH(J).LE.0) GO TO 60
          IYFLAG(J) = 1
          NBON = NBON + 1
          IF(NBON.GT.MBON) GO TO 900
          CALL WKBOND(I,J)
   60     CONTINUE
        IYFLAG(I) = 1
        GO TO 100
   70   XH2=XH2+OCCU(I)*NPOS(I)
        DO 80 J=1,NX
          IF(ND(J).LE.0) GO TO 80
          IYFLAG(J) = 1
          NBON = NBON + 1
          IF(NBON.GT.MBON) GO TO 900
          CALL WKBOND(I,J)
   80     CONTINUE
        IYFLAG(I) = 1
  100   CONTINUE
        ELSE
        DO 110 I=1,NXH
          IF(GDH(I).EQ.'H'.OR.GDH(I).EQ.'D') XH2=XH2+XNUMH(I)
  110   CONTINUE
        ENDIF
      NH1=INTEGER(XH1,0)
      NH2=INTEGER(XH2,0)
      IF(ABS(XH1-XH2).GT.0.5) THEN
        IFFLAG=IFFLAG+1
        WRITE (NOUT,1001) XH2, XH1
 1001 FORMAT ('0',15X,F5.1,'dummy H given;',F5.1,' assigned')
      ENDIF
      RETURN
  900 IF(NBON.EQ.MBON+1) WRITE(NOUT,9001) MBON
 9001 FORMAT(5X,'***ERROR***DUMMYH***9001*** MORE THAN ',
     + I4,' BONDS, REMAINDER NOT STORED')
      RETURN
      END
c
c
***********************************************************************
c
c
      subroutine indepb(nn,nk1,nk2)
c
c     calls cobotr, symtrn
c
c     checks through common /bonds/ (for nn=1) or common /contac/
c     (nn=2) from nk1 to nk2 and stores in inde1/inde2 the bond/contact numbers
c     of the independent representation of each bond
c
c     the contacts from 1 to nk2 are being redefined with subroutine cobotr!!
c
c     written by D. Altermatt
c     McMaster University, Feb. 1985
c
c     system common blocks
c
      common /files/  nin,nout,ndebug,nread,nwrite,nspgp,machine,nterm
      common /sym/    nsym,msym,s(3,3,48),t(3,48),nlt,tu(3,4)
      include 'combond.for'
c
      dimension lq(3),kcon(10,1000),lt(3),xt(3),lcon(10,1000)
c
      if(nk2.lt.nk1) return
      if(nn.eq.1) goto 50
      if(ndebug.ne.0) write(ndebug,2030) nk1,nk2
 2030 format(' ++DEBUG++INDEPB++2030++ DO CONTACTS FROM',I4,' TO',I4)
      do 10 i=1,nk2
        n=1
        call cobotr(n,icon(1,i),icon(2,i),icon(3,i),jcon(1,i),jcon(2,i),
     1    jcon(3,i))
        do 30 j=1,5
          lcon(j+5,i)=icon(j,i)
          lcon(j,i)=jcon(j,i)
          kcon(j+5,i)=jcon(j,i)
30        kcon(j,i)=icon(j,i)
        n=-1
        call cobotr(n,lcon(1,i),lcon(2,i),lcon(3,i),lcon(6,i),lcon(7,i),
     1    lcon(8,i))
        if(ndebug.ne.0) write(ndebug,2000) i,(kcon(j,i),j=1,10),
     1    (lcon(j,i),j=1,10)
 2000   format(' ++DEBUG++INDEPB++2000++ I=',I4,', KCON(I):',10I4,/,
     1    33X,'LCON(I):',10I4)
10      continue
      goto 100
50    if(ndebug.ne.0) write(ndebug,2040) nk1,nk2
 2040 format(' ++DEBUG++INDEPB++2040++ DO BONDS FROM',I4,' TO',I4)
      do 60 i=1,nk2
        n=-1
        call cobotr(n,ibon(1,i),ibon(2,i),ibon(3,i),jbon(1,i),jbon(2,i),
     1    jbon(3,i))
        do 70 j=1,5
          kcon(j,i)=ibon(j,i)
70        kcon(j+5,i)=jbon(j,i)
        do 80 j=1,5
          lcon(j,i)=kcon(j+5,i)
80        lcon(j+5,i)=kcon(j,i)
        n=-1
        call cobotr(n,lcon(1,i),lcon(2,i),lcon(3,i),lcon(6,i),lcon(7,i),
     1    lcon(8,i))
        if(ndebug.ne.0) write(ndebug,2000) i,(kcon(j,i),j=1,10),
     1    (lcon(j,i),j=1,10)
60      continue
100   do 110 i=nk1,nk2
        if(nn.eq.1) then
          ind1=i
          inde1(i)=i
          if(jbon(2,i).le.0) inde1(i)=0
          isp=inde1(i)
        else
          ind2=i
          inde2(i)=i
          if(kcon(7,i).le.0.or.kcon(2,i).le.0) inde2(i)=0
          isp=inde2(i)
          endif
        j=i-1
        if(isp.le.0.or.j.eq.0) goto 110
        n=1
        m=1
        do 115 l=1,nsym
          call symtrn(n,isp,lt,kcon(6,i),kcon(7,i),kcon(8,i),
     1      kcon(1,i),kcon(2,i),kcon(3,i),xt)
          call symtrn(m,jsp,lq,lcon(6,i),lcon(7,i),lcon(8,i),
     1      lcon(1,i),lcon(2,i),lcon(3,i),xt)
          if(ndebug.ne.0) write(ndebug,2010) n,kcon(6,i),isp,(lt(k),
     1      k=1,3),i,m,lcon(6,l),jsp,(lq(k),k=1,3)
 2010     format(' ++DEBUG++INDEPB++2010++ N=',I4,', KCON(6)=',I4,
     1      ', ISP=',I4,', LT:',3I4,', I=',I4,/,24X,' M=',I4,
     2      ', LCON(6)=',I4,', JSP=',I4,', LQ:',3I4)
          if(m.le.0.and.n.le.0) goto 110
          do 120 k=1,j
            if(kcon(1,i).ne.kcon(1,k).or.kcon(6,i).ne.kcon(6,k))
     1        goto 120
            if(n.le.0) goto 130
            if(isp.eq.kcon(7,k)) then
              if(lt(1).eq.kcon(8,k).and.lt(2).eq.kcon(9,k).
     1          and.lt(3).eq.kcon(10,k)) then
                if(nn.eq.1) inde1(i)=inde1(k)
                if(nn.eq.2) inde2(i)=inde2(k)
                if(ndebug.ne.0) write(ndebug,2020) k
 2020           format('+',72X,', K=',I4)
                goto 110
                endif
              endif
            if(kcon(1,i).eq.lcon(1,k).and.kcon(6,i).eq.lcon(6,k)) then
              if(isp.eq.lcon(7,k)) then
                if(lt(1).eq.lcon(8,k).and.lt(2).eq.lcon(9,k).
     1            and.lt(3).eq.lcon(10,k)) then
                  if(nn.eq.1) inde1(i)=inde1(k)
                  if(nn.eq.2) inde2(i)=inde2(k)
                  if(ndebug.ne.0) write(ndebug,2020) k
                  goto 110
                  endif
                endif
              endif
130         if(m.le.0) goto 120
            if(jsp.eq.lcon(7,k)) then
              if(lq(1).eq.lcon(8,k).and.lq(2).eq.lcon(9,k).
     1          and.lq(3).eq.lcon(10,k)) then
                if(nn.eq.1) inde1(i)=inde1(k)
                if(nn.eq.2) inde2(i)=inde2(k)
                if(ndebug.ne.0) write(ndebug,2020) k
                goto 110
                endif
              endif
            if(lcon(1,i).eq.kcon(1,k).and.lcon(6,i).eq.kcon(6,k)) then
              if(jsp.eq.kcon(7,k)) then
                if(lq(1).eq.kcon(8,k).and.lq(2).eq.kcon(9,k).
     1            and.lq(3).eq.kcon(10,k)) then
                  if(nn.eq.1) inde1(i)=inde1(k)
                  if(nn.eq.2) inde2(i)=inde2(k)
                  if(ndebug.ne.0) write(ndebug,2020) k
                  goto 110
                  endif
                endif
              endif
120         continue
          if(n.le.0) n=nsym
          if(m.le.0) m=nsym
          n=n+1
          m=m+1
115       continue
110     continue
      return
      end
c
c
***********************************************************************
c
c
      subroutine cbredu(nn,nk1,nk2)
c
c     calls indepb
c
c     remove all dependent bonds (nn=1) and contacts (nn=2) between
c     positions nk1 and nk2
c
c     written by D. Altermatt
c     McMaster University, March 1985
c
      implicit character*8 (g)
      implicit character*80 (h)
c
c     system common blocks
c
      common /files/  nin,nout,ndebug,nread,nwrite,nspgp,machine,nterm
      include 'combond.for'
c
      if(nk2.lt.nk1) return
      itfl=0
      if(nn.eq.1) then
        i10 = 1
        if(ind1.lt.nbon) call indepb(i10,(ind1+1),nbon)
        if(nk2.lt.nbon) itfl=1
        if(nk2.gt.nbon) nk2=nbon
        do 10 i=nk1,nk2
10        if(inde1(i).lt.i) inde1(i)=0
        nl1=nk1
        nl2=nk2
20      nl3=nl1
        nl4=nl2
        do 30 i=nl3,nl4
          nl1=i
          if(inde1(i).eq.0) then
            nbon=nbon-1
            if(nbon.eq.0.or.nbon.lt.nl1) return
            do 40 j=nl1,nbon
              inde1(j)=inde1(j+1)
              do 50 l=1,6
                xbon(l,j)=xbon(l,j+1)
                if(l.gt.5) goto 50
                ibon(l,j)=ibon(l,j+1)
                jbon(l,j)=jbon(l,j+1)
                if(l.gt.4) goto 50
                ifbon(l,j)=ifbon(l,j+1)
50              continue
40            continue
            nl2=nl2-1
            goto 20
            endif
30        continue
        if(itfl.eq.1) then
          i10 = 1
          call indepb(i10,nk1,nbon)
        else
          do 200 i=nk1,nbon
200         inde1(i)=i
          ind1=nbon
          endif
        return
      else
        i20 = 2
        if(ind2.lt.ncon) call indepb(i20,(ind2+1),ncon)
        if(nk2.lt.ncon) itfl=1
        if(nk2.gt.ncon) nk2=ncon
        do 60 i=nk1,nk2
60        if(inde2(i).lt.i) inde2(i)=0
        nl1=nk1
        nl2=nk2
70      nl3=nl1
        nl4=nl2
        do 80 i=nl3,nl4
          nl1=i
          if(inde2(i).eq.0) then
            ncon=ncon-1
            if(ncon.eq.0.or.ncon.lt.nl1) return
            do 90 j=nl1,ncon
              inde2(j)=inde2(j+1)
              do 100 l=1,6
                xcon(l,j)=xcon(l,j+1)
                if(l.gt.5) goto 100
                icon(l,j)=icon(l,j+1)
                jcon(l,j)=jcon(l,j+1)
                if(l.gt.4) goto 100
                ifcon(l,j)=ifcon(l,j+1)
100             continue
90            continue
            nl2=nl2-1
            goto 70
            endif
80        continue
        if(itfl.eq.1) then
          i20 = 2
          call indepb(i20,nk1,ncon)
        else
          do 210 i=nk1,ncon
210         inde2(i)=i
          ind2=ncon
          endif
        return
        endif
      end
c
c
***********************************************************************
c
c
c
      subroutine bonfit(i,j,js,jl,k,ks,kl)
c
c    written 85.3.26 by I.D.Brown
c
c    if bond(i) is formed to atom j, then k is the atom at the other
c    end of the bond.  js,jl,k,ks,kl are returned.  If not, k=0
c
c
      include 'combond.for'
c
      dimension jl(3),kl(3)
c
      k=0
      if(j.eq.ibon(1,i)) then
        js=ibon(2,i)
        k=jbon(1,i)
        ks=jbon(2,i)
        do 100 l=1,3
          jl(l)=ibon(l+2,i)
          kl(l)=jbon(l+2,i)
  100     continue
      else if(j.eq.jbon(1,i)) then
        k=ibon(1,i)
        ks=ibon(2,i)
        js=jbon(2,i)
        do 200 l=1,3
          jl(l)=jbon(l+2,i)
          kl(l)=ibon(l+2,i)
  200     continue
        endif
      return
      end
c
c
***********************************************************************
c
      function ibondy(i,j,iflag)
c
c   written 1986.3.17 by I.D.Brown
c
c   returns the address in /bonds/ of the bond between atoms i and j in /yatom/
c   in comparing the bond between the coordinates given by i and j it will
c   will look for a full match if iflag=5, but it will only look for a match
c   between the atom number and the symmetry operator (ignoring translations)
c   if iflag=2
c
c   calls symlib:getstl
c         mathlb:jcomve
c
      common /files/ nin,nout,ndebug,nread,nwrite,nspgr,machine,nterm
      include 'comatom.for'
      include 'combond.for'
      dimension lbon(5),llbon(5)
c
c
      lbon(1)=iynum(i)
      lbon(2)=iysym(i)
      llbon(1)=iynum(j)
      llbon(2)=iysym(j)
      call getstl(lbon(3),lbon(1),yx(1,i),lbon(2))
      call getstl(llbon(3),llbon(1),yx(1,j),llbon(2))
      if(ndebug.ne.0) write (ndebug,1000) (lbon(k),k=1,5),
     +                (llbon(k),k=1,5)
 1000 format(' *debug*ibondy*1000* ',2(1X,5I3))
      do 100 k=1,nbon
        if(jcomve(lbon,ibon(1,k),iflag).eq.0.and.
     +     jcomve(llbon,jbon(1,k),iflag).eq.0) then
          ibondy=k
          return
        else if(jcomve(llbon,ibon(1,k),5).eq.0.and.
     +          jcomve(lbon,jbon(1,k),5).eq.0) then
          ibondy=k
          return
          endif
  100   continue
      ibondy=0
      return
      end
c
***********************************************************************
c
      subroutine chebon(i,nn,nbon,ibon)
c
c     searches ibon(1,nn+1) to ibon(1,nbon) for atom =i= in ibon(1,j)
c     nn=j if found, else nn=0
c
c     Written by D. Altermatt
c     McMaster University, Feb. 1985
c
      dimension ibon(5,nbon)
c
      jj=0
      nn=nn+1
      do 10 j=nn,nbon
        if(ibon(1,j).eq.i) then
          jj=j
          goto 20
          endif
10      continue
20    nn=jj
      return
      end
c
c
***********************************************************************
c
c
      subroutine checon(i,nn,ncon,icon,jcon,ipn1,ipn2)
c
c     searches from icon(1,nn+1) to icon(6,ncon) for atom =i= in
c     icon(ipn1,j)
c
c     nn=j, ipn1=ligand position of =i=, ipn2=(ipn1+5) modulo 10
c     if found, else nn=0
c
c     written by D. Altermatt
c     McMaster university, feb. 1985
c
      dimension icon(5,ncon),jcon(5,ncon)
c
      jj=0
      nn=nn+1
      do 10 j=nn,ncon
        if(icon(1,j).eq.i) then
          jj=j
          ipn1=1
          ipn2=6
          goto 20
        else if(jcon(1,j).eq.i) then
          jj=j
          ipn1=6
          ipn2=1
          goto 20
          endif
10      continue
20    nn=jj
      return
      end
c
c
***********************************************************************
c
c
      subroutine cobotr(n,i,isp,li,j,jsp,lj)
c
c     calls invsop, mltstl
c
c     if N.gt.0 input will be rearranged so that I.lt.J
c
c     transforms the bond/contact given so that atom I gets to
c     ISP = 1 and LI(3) = (0,0,0)
c
c     n=0 as error output
c
c     written by D. Altermatt
c     McMaster University, March 1985
c
c
c     system common blocks
c
      common /files/  nin,nout,ndebug,nread,nwrite,nspgp,machine,nterm
      common /sym/    nsym,msym,s(3,3,48),t(3,48),nlt,tu(3,4)
      include 'comatom.for'
      common /syma/   mult(48,48),it(3,48),nsp,msp,isptab(48,30),
     1                multsp(30),sp(3,3,30),tp(3,30)
c
      dimension li(3),lj(3),lk(3),l0(3)
      data (l0(i),i=1,3)/0,0,0/
c
      if(n.lt.0) goto 20
      if(j.lt.i) then
        k=i
        i=j
        j=k
        ksp=isp
        isp=jsp
        jsp=ksp
        do 10 l=1,3
          lk(l)=li(l)
          li(l)=lj(l)
 10       lj(l)=lk(l)
        endif
c
 20   n=1
      if(isp.eq.1.and.(iabs(li(1))+iabs(li(2))+iabs(li(3))).eq.0) return
      if(ialtno(i).le.0.or.ialtno(j).le.0) then
        n=0
        return
        endif
c
      call invsop(n,ksp,lk,isp,li,ialtno(i),l0)
      if(n.le.0) then
        n=0
        return
        endif
      call mltstl(isp,li,ksp,lk,jsp,lj,ialtno(j))
      jsp=isp
      isp=1
      do 30 l=1,3
        lj(l)=li(l)
 30     li(l)=0
      return
      end
c
c
***********************************************************************
c
c
c
      subroutine bocole(n,k1,k2)
c
c   written 85.3.21 (300th birthday of JSB) by I.D.Brown
c
c    This subroutine updates the distances etc in the bond
c    array (n=1) or the contact array (n=2)
c
c    this subroutine calls symopl, vminv and dist
c
      implicit character*8 (g)
      implicit character*80 (h)
c
c     system common blocks
c
      common /files/  nin,nout,ndebug,nread,nwrite,nspgp,machine,nterm
      common /cell/   a,b,c,alpha,beta,agamma,vol,am(3,3),icell
      common /sym/    nsym,msym,s(3,3,48),t(3,48),nlt,tu(3,4)
      include 'comatom.for'
      include 'combond.for'
      dimension x1(3),x2(3),dx(3)
c
      berr=100.
      cerr=50.
      if(n.eq.1) then
        do 100 i=k1,k2
          i1=ibon(1,i)
          i2=jbon(1,i)
          is1=ibon(2,i)
          is2=jbon(2,i)
          call symopl(x1,s(1,1,is1),t(1,is1),ibon(3,i),xx(1,i1))
          call symopl(x2,s(1,1,is2),t(1,is2),jbon(3,i),xx(1,i2))
          call vminv(dx,x2,x1)
          xbon(1,i)=dist(dx,am)
          xbon(2,i)=xbon(1,i)/berr
          do 90 j=1,3
   90       xbon(3+j,i)=dx(j)
  100     continue
      else if(n.eq.2) then
        do 200 i=k1,k2
          i1=icon(1,i)
          i2=jcon(1,i)
          is1=icon(2,i)
          is2=jcon(2,i)
          call symopl(x1,s(1,1,is1),t(1,is1),icon(3,i),xx(1,i1))
          call symopl(x2,s(1,1,is2),t(1,is2),jcon(3,i),xx(1,i2))
          call vminv(dx,x2,x1)
          xcon(1,i)=dist(dx,am)
          xcon(2,i)=xcon(1,i)/cerr
          do 190 j=1,3
  190       xcon(3+j,i)=dx(j)
  200     continue
        endif
      return
      end
c
***********************************************************************
c
      subroutine corget
c     -----------------
c
c     calls abost, acid, bocole, bost, calcy, cbredu, cobotr, contac,
c           dbost, getstl, indepb, inerr, integer, ivpluv, ldval,
c             naltno, readyn, sorty, xleng, calcon
c
c     explores the interatomic distances in the environment of specified
c     atomic positions, updates the coordination numbers, defines bonds
c     and contacts and updates common /bonds/ and common /contac/ selectively
c
c     written by D. Altermatt
c     McMaster University, Jan/Feb. 1985
c
      implicit character*80 (h)
      implicit character*8 (g)
c
      common /files/   nin,nout,ndebug
      common /cell/    clat(6)
      include 'comatom.for'
      include 'combond.for'
      common /sym/     nsym,msym,s(3,3,48),t(3,48)
      common /gsym/    glat,gcent,hmsym,hall,gsysp(2,30)
      common /syma/    mult(48,48),it(3,48),nsp,msp,isptab(48,30),
     1                   mults(30),sp(3,3,30),tp(3,30)
c ---PROGRAMMER'S NOTE:  /bost/ changed to /bostt/ for unix
      common /bostt/    nbost,mbost,ioxbost(2,30),ifbost(30),
     1                   pbost(5,30)
      common /gbost/   gbost(2,30)
c
      dimension x(3),nt(3),xmin(3),xmax(3),idista(7,30),xdista(30,2),
     1      gdista(3,30),npoint(30),lt(3),iupd(10),li(3),l0(3),lcon(10)
      data (l0(i),i=1,3)/0,0,0/
c
c     check if there are known positions
c     ----------------------------------
      do 5 i=1,nx
    5   if(ialtno(i).ge.1) goto 8
      write(nout,2005)
2005  format(//,' Check atom list. No special position flags',
     +  ' assigned yet !',//)
      call wait
    6 return
c
c     weights for distance least-squares
c     ----------------------------------
    8 berr=100.
      cerr=50.
      write(nout,2017)
 2017 format(' Do you wish to generate all the contacts in the cell ',
     +  '(Y/N/E)  ')
      call readyn(*9,*10,*999,*8)
      xlim=0.0
    9 call calcon(xlim)
      write(nout,2018) ncon
 2018 format(/,I5,' contacts calculated')
c
c     First list the known positions
c     ------------------------------
10    write(nout,2000)
2000  format(/,' Do you want a listing of the known positions',
     1    ' (Y/N/E): ')
      call readyn(*15,*50,*999,*10)
15    write(nout,2010)
2010  format(//,' Listing of known positions',/,
     1    ' Nr. Elem. Ident. Coordinates              Mult.',
     2    ' Symmetry Co.Num. Bonds',/)
2020  format(1X,I3,1X,A2,2X,A8,1X,3F8.4,1X,I4,2X,A8,3X,I3,4X,I3)
      linc=0
      do 20 i=1,nx
        linc=linc+1
        if(npos(i).le.0) goto 20
        nci=0
        kbon=0
        if(nbon.ne.0) then
          do 30 j=1,nbon
            if(ibon(1,j).eq.i.or.jbon(1,j).eq.i) then
              kbon=kbon+ifbon(1,j)
              if(jbon(2,j).ne.0) nci=nci+ifbon(1,j)
              endif
30          continue
          endif
        if(nci.gt.icn(i)) icn(i)=nci
        if(ialtno(i).eq.0) then
35        call naltno(xx(1,i),npos(i),ialtno(i),n1,n2,nt)
          if(ialtno(i).eq.0) then
            npos(i)=0
            goto 35
            endif
          endif
        write(nout,2020) i,gelem(i),gdent(i),(xx(k,i),k=1,3),npos(i),
     1      gsysp(2,ialtno(i)),icn(i),kbon
        if(linc.eq.19.and.i.ne.nx) then
          linc=0
          write(nout,2030)
2030      format(/,' Hit <RETURN> to continue listing: ')
          read(nin,1000,err=40) gdum
1000      format(A1)
40        write(nout,2010)
          endif
20      continue
c
c     get an atom, reset and fill its environment to /yatom/
c     ------------------------------------------------------
50    write(nout,2040)
2040  format(//,' Choose an atom, enter its number in list: ')
      read(nin,1010,err=55) k
1010  format(I5)
      goto 60
55    call inerr(*50)
60    corad=0.0
      write(nout,2045)
2045  format(//,' Check spherical environment with FIXED radius',
     1  ' (Y/N/E): ')
      call readyn(*65,*600,*999,*60)
600   write(nout,2048)
2048  format(/,' Enter radius of sphere (0.5<rad<5.1): ')
      read(nin,1020,err=610) corad
      if(corad.gt.5.1) corad=5.1
      if(corad.lt.0.5) corad=0.5
      goto 65
610   call inerr(*600)
65    ny=0
      do 70 i=1,3
        xmin(i)=xx(i,k)-5./clat(i)
70      xmax(i)=xx(i,k)+5./clat(i)
      call calcy(xmax,xmin)
      do 75 i=1,30
        do 75 j=1,7
        idista(j,i)=0
        if(j.gt.3) goto 75
        gdista(j,i)=' '
        if(j.gt.2) goto 75
        xdista(i,j)=0.0
75      continue
c
c     get all distances less than 1.5*contact-distance or CORAD, rsp.
c     first load known ones
c     ---------------------------------------------------------------
      mp=0
      ndist=0
      i10 = 1
      if(nbon.gt.0) call bocole(i10,i10,nbon)
      do 85 i=1,nbon
        if(ibon(1,i).ne.k.and.jbon(1,i).ne.k) goto 85
        if(npos(ibon(1,i)).lt.0.or.npos(jbon(1,i)).lt.0) goto 85
        mp=mp+1
        ndist=ndist+1
        idista(1,ndist)=k
        idista(3,ndist)=i
        xdista(ndist,1)=xbon(1,i)
        if(ifbon(4,i).le.1) then
          if(xbon(3,i).lt.0.005) xbon(3,i)=acid(nza(1,ibon(1,i)),
     1      nza(2,ibon(1,i)),oxid(ibon(1,i)))
          xdista(ndist,2)=dbost(gelem(ibon(1,i)),gelem(jbon(1,i)),oxid
     1      (ibon(1,i)),oxid(jbon(1,i)),xbon(3,i))
          if(xdista(ndist,2).lt.0.1) then
            xdista(ndist,2)=0.8*contac(nza(1,ibon(1,i)),
     1        nza(1,jbon(1,i)))
            endif
        else if(ifbon(4,i).eq.2) then
          xdista(ndist,2)=-xbon(3,i)
        else
          xdista(ndist,2)=0.8*contac(nza(1,ibon(1,i)),nza(1,jbon(1,i)))
          endif
        gdista(1,ndist)='bond'
        gdista(2,ndist)='stored'
        gdista(3,ndist)='   '
        if(k.eq.ibon(1,i)) then
          idista(2,ndist)=jbon(1,i)
          idista(4,ndist)=jbon(2,i)
          call ivpluv(idista(5,ndist),jbon(3,i),l0)
        else
          idista(2,ndist)=ibon(1,i)
          nn=jbon(2,i)
          call ivpluv(lt,jbon(3,i),l0)
          idista(4,ndist)=1
          n=-1
          call cobotr(n,k,nn,lt,ibon(1,i),idista(4,ndist),
     1        idista(5,ndist))
          endif
85      continue
      i10 = 1
      i20 = 2
      if(ncon.gt.0) call bocole(i20,i10,ncon)
      do 95 i=1,ncon
        if(icon(1,i).ne.k.and.jcon(1,i).ne.k) goto 95
        if(npos(icon(1,i)).lt.0.or.npos(jcon(1,i)).lt.0) goto 95
        ndist=ndist+1
        idista(1,ndist)=k
        idista(3,ndist)=i
        xdista(ndist,1)=xcon(1,i)
        xdista(ndist,2)=xcon(3,i)
        gdista(1,ndist)='contact'
        gdista(2,ndist)='stored'
        gdista(3,ndist)='aim'
        if(ifcon(2,i).eq.1) gdista(3,ndist)='min'
        if(ifcon(2,i).eq.2) gdista(3,ndist)='max'
        if(k.eq.icon(1,i)) then
          idista(2,ndist)=jcon(1,i)
          idista(4,ndist)=jcon(2,i)
          call ivpluv(idista(5,ndist),jcon(3,i),l0)
          nn=icon(2,i)
          call ivpluv(lt,icon(3,i),l0)
        else
          idista(2,ndist)=icon(1,i)
          nn=jcon(2,i)
          call ivpluv(lt,jcon(3,i),l0)
          idista(4,ndist)=icon(2,i)
          call ivpluv(idista(5,ndist),icon(3,i),l0)
          endif
        n=-1
        call cobotr(n,k,nn,lt,icon(1,i),idista(4,ndist),
     1      idista(5,ndist))
95      continue
c
c     search environment for more possible contacts and bonds
c     -------------------------------------------------------
      do 80 i=1,ny
        do 90 j=1,3
90        x(j)=(-xx(j,k)+yx(j,i))
        dist=xleng(x(1),x(2),x(3),0)
        condis=contac(nza(1,k),nza(1,iynum(i)))
        if(corad.lt.0.5) corad=1.5*condis
        if(dist.lt.0.01.or.dist.gt.corad) goto 80
        call getstl(lt,iynum(i),yx(1,i),iysym(i))
        gxx='new'
        do 500 l=1,ndist
          if(idista(2,l).ne.iynum(i).or.gdista(2,l).eq.'depend')
     1        goto 500
          if(abs(dist-xdista(l,1)).lt.0.0001) then
            gxx='depend'
            ndp=l
            endif
          if(idista(4,l).ne.iysym(i)) goto 500
          do 510 ll=1,3
510         if(lt(ll).ne.idista(ll+4,l)) goto 500
          goto 80
500       continue
        ndist=ndist+1
        nn=ndist
        if(ndist.gt.30) then
          ymax=0.0
          do 100 j=1,30
            if(xdista(j,1).gt.ymax) then
              if(gdista(2,j).eq.'stored') goto 100
              ymax=xdista(j,1)
              nn=j
              endif
            ndist=30
100         continue
          endif
        idista(1,nn)=k
        idista(2,nn)=iynum(i)
        idista(3,nn)=0
        idista(4,nn)=iysym(i)
        call ivpluv(idista(5,nn),lt,l0)
        xdista(nn,1)=dist
        xdista(nn,2)=condis
        gdista(1,nn)=' '
        gdista(2,nn)=gxx
        gdista(3,nn)='aim'
        if(gxx.eq.'depend') then
          idista(3,nn)=ndp
          xdista(nn,2)=xdista(ndp,2)
          gdista(1,nn)=gdista(1,ndp)
          gdista(3,nn)=gdista(3,ndp)
          if(gdista(1,ndp).eq.'bond'.and.gdista(2,ndp).eq.'stored')
     1      mp=mp+1
          endif
80      continue
c
c     display what we got
c     -------------------
      call sorty(ndist,xdista(1,1),npoint)
380   write(nout,2050)
2050  format(//,' Proposal for bonds and contacts:',/,
     1    ' Nr.  from       to         Symmetry   Distance',
     2    '  Expected',/)
      linc=0
      do 110 i=ndist,1,-1
        if(gdista(2,npoint(i)).eq.'remove'.or.gdista(2,npoint(i))
     1      .eq.'drop') goto 110
        linc=linc+1
        n1=idista(1,npoint(i))
        n2=idista(2,npoint(i))
        n4=ndist-i+1
        if(gdista(2,npoint(i)).eq.'depend'.and.gdista(1,npoint(i))
     1      .ne.' ') then
          if(gdista(2,idista(3,npoint(i))).eq.'remove'.or.
     1        gdista(2,idista(3,npoint(i))).eq.'drop') then
            gdista(2,npoint(i))='drop'
            if(gdista(1,npoint(i)).eq.'bond') mp=mp-1
            goto 110
          else if(idista(3,idista(3,npoint(i))).lt.0) then
            if(gdista(1,npoint(i)).eq.'bond') mp=mp-1
            gdista(1,npoint(i))=gdista(1,idista(3,npoint(i)))
            if(gdista(1,npoint(i)).eq.'bond') mp=mp+1
            endif
          xdista(npoint(i),2)=xdista(idista(3,npoint(i)),2)
          endif
        if(gdista(1,npoint(i)).ne.' ') goto 135
        gdista(1,npoint(i))='contact'
        if(oxid(n1).lt.-0.01.and.oxid(n2).ge.0.0.or.oxid(n1).ge.
     1      0.0.and.oxid(n2).lt.-0.01) then
          if(nbost.eq.0) goto 130
          do 120 j=1,nbost
            if(gelem(n1).eq.gbost(1,j).and.gelem(n2).eq.gbost(2,j).
     1          and.integer(oxid(n1),0).eq.ioxbost(1,j).and.integer
     2          (oxid(n2),0).eq.ioxbost(2,j)) goto 140
            if(gelem(n2).eq.gbost(1,j).and.gelem(n1).eq.gbost(2,j).
     1          and.integer(oxid(n2),0).eq.ioxbost(1,j).and.integer
     2          (oxid(n1),0).eq.ioxbost(2,j)) goto 140
120         continue
130       call ldval(gelem(n1),gelem(n2),oxid(n1),oxid(n2),ier)
          if(ier.ne.0) goto 135
140       nn=n1
          if(oxid(n2).ge.0.0) nn=n2
          xacid=acid(nza(1,nn),nza(2,nn),oxid(nn))
          call abost(gelem(n1),gelem(n2),integer(oxid(n1),0),integer
     1        (oxid(n2),0),xacid,condis)
          if(xdista(npoint(i),1).lt.(1.2*condis)) then
            gdista(1,npoint(i))='bond'
            gdista(3,npoint(i))='   '
            mp=mp+1
            xdista(npoint(i),2)=condis
            endif
          endif
135     write(nout,2060) n4,gelem(n1),gdent(n1),gelem(n2),gdent(n2),
     1      (idista(j,npoint(i)),j=4,7),xdista(npoint(i),1),xdista
     2      (npoint(i),2),gdista(3,npoint(i)),(gdista(j,npoint(i)),
     3      j=1,2)
2060    format(1X,I3,2X,A2,1X,A6,2X,A2,1X,A6,4I3,1X,2(F7.4,3X),A3,1X
     1      ,A8,2X,A6)
        if(linc.eq.19.and.i.ne.1) then
          linc=0
          write(nout,2030)
          read(nin,1000,err=115) gdum
115       write(nout,2050)
          endif
110     continue
      write(nout,2030)
      read(nin,1000,err=145) gdum
c
c     select next function from a menu
c     --------------------------------
145   write(nout,2070)
2070  format(/,' Do you want to:',//,
     1    '   1: Remove bonds/contacts from the list',/,
     2    '   2: Change bond/contact assignments',/,
     3    '   3: Update target (expected) distances',/,
     4    '   4: Store the NEW bonds to the bond list',/,
     5    '   5: Store the NEW contacts to the contact list',/,
     6    '   6: Update coordination number of chosen atom',/,
     7    '   7: Update ALREADY STORED bonds/contacts and check new',
     +         ' atom',/,
     8    '   8: Update ALREADY STORED bonds/contacts and EXIT',/,
     *    '   9: EXIT without any updates',//,
     9    ' Enter your selection: ')
      read(nin,1010,err=155) isel
      if(isel.eq.9) goto 999
      msel=8
      if(isel.lt.1.or.isel.gt.msel) goto 155
      goto (210,150,410,185,275,350,325,325) isel
155   call inerr(*145)
c
c     MENU 1 removal of bonds/contacts from list
c     -----------------------------------------
210   write(nout,2170)
2170  format(/,' Number in list to be removed (0 to exit): ')
      read(nin,1010,err=210) nn
      if(nn.eq.0) goto 220
      if(nn.lt.1.or.nn.gt.ndist) call inerr(*210)
      nn=ndist-nn+1
      nn=npoint(nn)
      if(gdista(2,nn).eq.'remove'.or.gdista(2,nn).eq.'drop')
     1    call inerr(*210)
      if(gdista(1,nn).eq.'bond') mp=mp-1
      if(gdista(2,nn).eq.'stored') then
        gdista(2,nn)='remove'
      else
        gdista(2,nn)='drop'
        endif
      goto 210
220   write(nout,2180)
2180  format(/,' Display updated list (Y/N/E): ')
      call readyn(*380,*145,*999,*220)
c
c     MENU 2 re-assignment of bond/contact flag
c     -----------------------------------------
150   write(nout,2080)
2080  format(/,' Number in list to be reassigned (0 to exit): ')
      read(nin,1010,err=160) nn
      if(nn.eq.0) goto 240
      if(nn.lt.1.or.nn.gt.ndist) call inerr(*150)
      goto 170
160   call inerr(*150)
170   n4=nn
      nn=ndist-nn+1
      nn=npoint(nn)
      if(gdista(2,nn).eq.'drop'.or.gdista(2,nn).eq.'remove')
     1    call inerr(*150)
165   n1=idista(1,nn)
      n2=idista(2,nn)
      if(gdista(1,nn).eq.'bond') then
        mp=mp-1
        gdista(1,nn)='contact'
        gdista(3,nn)='aim'
        xdista(nn,2)=contac(nza(1,n1),nza(1,n2))
        if(gdista(2,nn).eq.'stored') idista(3,nn)=-idista(3,nn)
      else
        if(oxid(n1).lt.0.0.and.oxid(n2).lt.0.0) goto 230
        if(oxid(n1).gt.0.0.and.oxid(n2).gt.0.0) goto 230
        if(gdista(2,nn).eq.'stored') idista(3,nn)=-idista(3,nn)
        gdista(1,nn)='bond'
        gdista(3,nn)='   '
        mp=mp+1
        n3=n1
        if(oxid(n3).lt.0.0) n3=n2
        xdista(nn,2)=dbost(gelem(n1),gelem(n2),oxid(n1),oxid(n2),
     1      acid(nza(1,n3),nza(2,n3),oxid(n3)))
        if(xdista(nn,2).lt.0.01) xdista(nn,2)=0.8*contac(nza(1,n1),
     1    nza(1,n2))
        endif
      write(nout,2050)
235   write(nout,2060) n4,gelem(n1),gdent(n1),gelem(n2),gdent(n2),
     1    (idista(j,nn),j=4,7),xdista(nn,1),xdista(nn,2),gdista(3,nn),
     2    (gdista(j,nn),j=1,2)
      if(gdista(2,nn).eq.'depend') then
        if(gdista(1,idista(3,nn)).eq.gdista(1,nn)) goto 150
        nn=idista(3,nn)
        n4=ndist-nn+1
        goto 165
        endif
      goto 150
230   write(nout,2090)
2090  format(//,' ***** Cannot assign the following distance as ',
     1    '"bond" *****',//)
      goto 325
240   write(nout,2180)
      call readyn(*380,*145,*999,*240)
c
c     MENU 3 update target distances
c     -------------------------------
410   write(nout,2220)
2220  format(/,' Enter number in list of bond/contact to be',
     1    ' updated (0 to exit): ')
      read(nin,1010,err=410) nn
      if(nn.eq.0) goto 175
      if(nn.lt.1.or.nn.gt.ndist) call inerr(*410)
      n4=nn
      nn=ndist-nn+1
      nn=npoint(nn)
      write(nout,2050)
      write(nout,2060) n4,gelem(idista(1,nn)),gdent(idista(1,nn)),
     1    gelem(idista(2,nn)),gdent(idista(2,nn)),(idista(j,nn),j=4,7),
     2    xdista(nn,1),xdista(nn,2),gdista(3,nn),(gdista(j,nn),j=1,2)
420   write(nout,2230) xdista(nn,2)
2230  format(/,' Old target: ',F7.4,',    Enter new target',
     1    ' distance (blank=no change): ')
      read(nin,1020,err=420) dist
1020  format(F10.0)
      if(dist.lt.0.1) go to 410
      xdista(nn,2)=dist
      if(gdista(1,nn).eq.'bond') goto 410
430   write(nout,2240) gdista(3,nn)
2240  format(/,' Old contact type: ',A3,//,' Enter new contact',
     1    ' type defining the target distance (aim/min/max): ')
      read(nin,1030,err=430) gdn
1030  format(A3)
      do 440 i=1,3
        if(ichar(gdn(i:i)).gt.ichar('z').or.ichar(gdn(i:i)).lt.
     1      ichar('a')) then
          idn=ichar(gdn(i:i))-ichar('A')
          idn=idn+ichar('a')
          gdn(i:i)=char(idn)
          endif
440     continue
      if(gdn.ne.'aim'.and.gdn.ne.'min'.and.gdn.ne.'max') call
     1    inerr(*430)
      gdista(3,nn)=gdn
      if(gdista(2,nn).eq.'depend') then
        xdista(idista(3,nn),2)=dist
        gdista(3,idista(3,nn))=gdn
        endif
      goto 410
175   write(nout,2180)
      call readyn(*380,*145,*999,*175)
c
c     MENU 4,7,8 update common /bonds/, add new bonds if selected
c     -----------------------------------------------------------
185   n5=0
      goto 330
325   n5=1
330   do 190 i=1,ndist
        if(gdista(1,i).eq.'contact'.and.idista(3,i).gt.0) goto 190
        if(gdista(1,i).eq.'contact'.and.idista(3,i).lt.0) then
          nn=iabs(idista(3,i))
          ibon(1,nn)=0
        else if(gdista(1,i).ne.'bond') then
          goto 190
        else if(gdista(2,i).eq.'drop'.or.gdista(2,i).eq.'depend')
     1      then
          goto 190
        else if(gdista(2,i).eq.'remove') then
          ibon(1,idista(3,i))=0
        else if(gdista(2,i).eq.'stored'.and.idista(3,i).gt.0) then
          nn=idista(3,i)
          call bost(ibon(1,nn),jbon(1,nn),xbon(3,nn),x1,x2,xdista(i,2))
          xbon(3,nn)=abs(xbon(3,nn))
          ifbon(4,nn)=1
          if(xbon(3,nn).lt.0.005) then
            xbon(3,nn)=-xdista(i,2)
            ifbon(4,nn)=2
            endif
        else if((n5.eq.0.and.gdista(2,i).eq.'new').or.
     1      (gdista(2,i).eq.'stored'.and.idista(3,i).lt.0)) then
          if(oxid(idista(1,i)).lt.0.0) then
            if(oxid(idista(2,i)).lt.0.0) goto 190
            iupd(1)=idista(2,i)
            iupd(2)=idista(1,i)
            call ivpluv(lt,l0,l0)
            isp=1
            n=-1
            call cobotr(n,iupd(1),idista(4,i),idista(5,i),iupd(2),isp,
     1          lt)
            call ivpluv(idista(5,i),lt,l0)
            idista(4,i)=isp
          else
            iupd(1)=idista(1,i)
            iupd(2)=idista(2,i)
            endif
          nbon=nbon+1
          if(nbon.gt.mbon) then
            write(nout,2100) mbon
2100        format(/,' **ERROR**CORGET**2100** MORE THAN',I4,
     1          ' BONDS',/)
            nbon=mbon
            goto 145
            endif
          jj=nbon
          ibon(1,jj)=iupd(1)
          ibon(2,jj)=1
          call ivpluv(ibon(3,jj),l0,l0)
          jbon(1,jj)=iupd(2)
          jbon(2,jj)=idista(4,i)
          call ivpluv(jbon(3,jj),idista(5,i),l0)
          ifbon(1,jj)=1
          xbon(1,jj)=xdista(i,1)
          xbon(2,jj)=xdista(i,1)/berr
          call bost(iupd(1),iupd(2),xbon(3,jj),x1,x2,xdista(i,2))
          xbon(3,jj)=abs(xbon(3,jj))
          ifbon(4,jj)=1
          if(xbon(3,jj).lt.0.005) then
            xbon(3,jj)=-xdista(i,2)
            ifbon(4,jj)=2
            endif
          endif
190     continue
      nn=0
200   nn=nn+1
      if(nn.gt.nbon) then
        if(isel.ge.(msel-1)) goto 285
        goto 145
        endif
      if(ibon(1,nn).eq.0) then
        nbon=nbon-1
        if(nbon.eq.0) then
          if(isel.ge.(msel-1)) goto 285
          goto 145
          endif
        do 195 j=nn,nbon
          do 195 l=1,6
          xbon(l,j)=xbon(l,j+1)
          if(l.gt.5) goto 195
          ibon(l,j)=ibon(l,j+1)
          jbon(l,j)=jbon(l,j+1)
          if(l.gt.4) goto 195
          ifbon(l,j)=ifbon(l,j+1)
195       continue
        nn=nn-1
        endif
      goto 200
c
c     update common /contac/, add new contacts if selected
c     ----------------------------------------------------
275   n5=0
      goto 320
285   n5=1
320   do 280 i=ndist,1,-1
        if(gdista(1,npoint(i)).eq.'bond'.and.idista(3,npoint(i))
     1      .gt.0) goto 280
        if(gdista(1,npoint(i)).eq.'bond'.and.idista(3,npoint(i))
     1      .lt.0) then
          nn=iabs(idista(3,npoint(i)))
          icon(1,nn)=0
        else if(gdista(1,npoint(i)).ne.'contact') then
          goto 280
        else if(gdista(2,npoint(i)).eq.'drop'.or.gdista(2,npoint(i))
     1      .eq.'depend') then
          goto 280
        else if(gdista(2,npoint(i)).eq.'remove') then
          icon(1,idista(3,npoint(i)))=0
        else if(gdista(2,npoint(i)).eq.'stored'.and.idista(3,npoint
     1      (i)).gt.0) then
          nn=idista(3,npoint(i))
          ifcon(2,nn)=0
          if(gdista(3,npoint(i)).eq.'min') ifcon(2,nn)=1
          if(gdista(3,npoint(i)).eq.'max') ifcon(2,nn)=2
          xcon(3,nn)=xdista(npoint(i),2)
        else if((n5.eq.0.and.gdista(2,npoint(i)).eq.'new').or.(gdista
     1      (2,npoint(i)).eq.'stored'.and.idista(3,npoint(i)).lt.0))
     2      then
          lcon(1)=idista(1,npoint(i))
          lcon(2)=1
          call ivpluv(lcon(3),l0,l0)
          lcon(6)=idista(2,npoint(i))
          lcon(7)=idista(4,npoint(i))
          call ivpluv(lcon(8),idista(5,npoint(i)),l0)
          x1=xdista(npoint(i),1)
          x2=xdista(npoint(i),2)
          g1=gdista(3,npoint(i))
          n=1
          call cobotr(n,lcon(1),lcon(2),lcon(3),lcon(6),lcon(7),
     1        lcon(8))
          ncon=ncon+1
          if(ncon.gt.mcon) then
            ncon=mcon
            write(nout,2160) mcon
2160        format(//,' *****ERROR: More than',I4,' contacts',//)
            goto 145
            endif
          do 390 j=1,5
            icon(j,ncon)=lcon(j)
            jcon(j,ncon)=lcon(j+5)
            if(j.gt.3) goto 390
            xcon(j+3,ncon)=0.0
            ifcon(j+1,ncon)=0
390         continue
          xcon(1,ncon)=x1
          xcon(2,ncon)=x1/cerr
          xcon(3,ncon)=x2
          ifcon(1,ncon)=1
          if(g1.eq.'min') ifcon(2,ncon)=1
          if(g1.eq.'max') ifcon(2,ncon)=2
          endif
280     continue
      nn=0
300   nn=nn+1
      if(nn.gt.ncon) then
        if(isel.ge.(msel-1)) goto 350
        goto 145
        endif
      if(icon(1,nn).eq.0) then
        ncon=ncon-1
        if(ncon.eq.0) then
          if(isel.ge.(msel-1)) goto 350
          goto 145
          endif
        do 310 j=nn,ncon
          do 310 l=1,6
          xcon(l,j)=xcon(l,j+1)
          if(l.gt.5) goto 310
          icon(l,j)=icon(l,j+1)
          jcon(l,j)=jcon(l,j+1)
          if(l.gt.4) goto 310
          ifcon(l,j)=ifcon(l,j+1)
310       continue
        nn=nn-1
        endif
      goto 300
c
c     update coordination number
c     --------------------------
350   write(nout,2200) gelem(k),gdent(k),icn(k),mp
2200  format(//,' Previous coordination number of ',A2,1X,A6,':',I3,
     1    ', updated to :',I3,//)
      icn(k)=mp
      if(isel.eq.(msel-1)) goto 10
      if(isel.eq.msel) goto 999
      goto 145
c
c     keep only the independent bonds and contacts
c     --------------------------------------------
999   i10 = 1
      call indepb(i10,i10,nbon)
      i10 = 1
      i20 = 2
      call indepb(i20,i10,ncon)
      i10 = 1
      call cbredu(i10,i10,nbon)
      i10 = 1
      i20 = 2
      call cbredu(i20,i10,ncon)
      return
      end
c
c
***********************************************************************
c
c
      FUNCTION IBONDX(I,J)
c
c   written 91.11.19 by I.D.Brown
c
c   returns the address in /bonds/ of the first bond found between atoms
c   i and j
c
      implicit character*8 (g)
      implicit character*80 (h)
      include 'combond.for'
c
      ibondx = 0
      do 100 k=1,nbon
        if((ibon(1,k).eq.i.and.jbon(1,k).eq.j).or.
     1     (ibon(1,k).eq.j.and.jbon(1,k).eq.i)) then
          ibondx = k
          return
          endif
  100   continue
      return
      end
c
