c          
c        File DUDPLOT                    Written: March, 1993
c                                                 T. Stephen
c        ____________
c
c  This file contains the following dummy functions:
c
c  F  PLOTEST: Shows that this has been installed rather than w77plot
c  F  VIDEO: 
c  F  SHADE: 
c  F  CIRCLE: 
c  F  LINE: 
c  F  CHARPLO: 
C  F  GLINT:   
c  F  CLEARSCREEN: 
c  F  BLUETORED: 
c  F  BOX: 
c  F  SIXTEENC:
c  F  BACKGROUND:
c
c If you do not have Watcom Fortran77 graphics libraries, compile this file.
c It provides dummy functions that will allow your linker to properly
c   link Strumo.  You will not be able to run any graphics routines.
c   These are:  Option 17, menu level 3, and the graphics valence maps.
c
c If you have the Watcom F77 graphics libraries, compile W77PLOT.FOR, and
c   DO NOT compile and include this file.
c
c The function comments are left for anyone who wishes to reconstruct them
c   for different libraries.
c
      FUNCTION PLOTTEST(iswitch)
c
c This tells the program which version of the plot drivers has been installed
c In iswitch 0 do not print test line
c            1 print test line
c Out Plottest 0 no VGA graphics (this file)
c              1 VGA graphics (w77plot.for)
      if (iswitch.eq.1) write(6,1000)
1000  format(7x,'*** VGA and SVGA graphics NOT installed ***')
      plottest=0
      return
      end
c
      FUNCTION VIDEO(imode)
c
c  Input IVGA=desired video mode
c  0- Return to defult mode
c  1- 16 colour, 640X480 Resolution- For standard VGA
c  2- 256 colour, 640X480 Resolution- Unsure of constraints
c  3- 256 colour, 1024X768 Resolution- Super VGA
      if (imode.ne.0) write(6,10)                      
10    format('You must have linked the program with W77PLOT.FOR,',/,
     + 'and the Watcom F77 graphics library in order to use the',/,
     + 'graphics procedures in Strumor.')
      video=0*imode
      return
      end
c
      function SHADE(itnfl)
c
c         This mess assigns a fading array of colours where 256 colour
c         palettes are available.  #16-31 are shades of colour 1,
c         #32-47 are shades of colour 2, etc.
c
      shade=0*itnfl
      return
      end

      FUNCTION CIRCLE(ifill,icox,icoy,irad,icol)
c
c This draws a circle with:
c   Centre: (icox,icoy) in pixel co-ordinates
c   Radius: irad pixels
c   Colour: icol, depends on palette
c   Filled/not filled: 1=fill, 0=don't
      circle=0*ifill*icox*icoy*irad*icol
      return
      end

      Function LINE(ix1,iy1,ix2,iy2,icol)
c
c     This function attempts to draw a line
c     From (ix1,iy1) to (ix2,iy2) in colour icol
c
      line=0*ix1*iy1*ix2*iy2*icol
      return
      end

      Function CHARPLO(is1,is2,ix1,ix2,ilen,gstring,icol)
c
c     This function attempts to draw the graphics string hstring
c     of character length ilen
c     of size (is1,is2) in pixels (along (x,y))
c     with top left corner at (ix1,ix2)
c     in colour icol.
c
      charplo=0*is1*is2*ix1*ix2*ilen*icol
      return
      end

      Function GLINT(ixpt,iypt,ilng,icol)
c
c     creates the little whit spot that is supposed to make tinted
c     balls look 3-D
c
      glint=0*ixpt*iypt*ilng*icol
      return
      end
c
      Function CLEARSCREEN(a)      
c
c     clears a graphics screen
c
      clearscreen=0*a
      return
      end
c
      Function BLUETORED(a)
c
c     Sets extended palette to go from blue to red through white
c     Uses colours 16 through 143
c
      bluetored=a*0
      return
      end

      Function BOX(ifill,ix1,iy1,ix2,iy2,icol)
c
c  This outputs a rectangle on a graphics screen with
c   upper left corner (ix1,iy1)
c   upper right corner (ix2,iy2)
c   colour icol
c   filled if ifill=1
c
      box=0*ifill*ix1*iy1*ix2*iy2*icol
      return
      end

      Function SIXTEENC(a)
c
c     Sets the colours 0-13 as Black to White to Blue
c     leaves 14 yellow, makes 15 green/red
c
      sixteenc=0*a
      return
      end
c
      Function BACKGROUND(icol)
c
c     Sets the background colour to icol
c
      background=0*icol
      return
      end
